config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  resources :people
  resources :processes do
    resources :phases, only: [:new, :create]
  end

  root to: 'home#index'
end

app/models/app_filters/people.rb
class AppFilters::People
  def initialize(params)
    @params = params
  end

  def filter
    filter_by_type
    filter_by_search_term
    @people
  end

  private

  [:search, :type].each do |key|
    define_method key do
      @params[key]
    end
  end


  def filter_by_type
    case type
    when 'physical'
      @people = PhysicalPerson.all
    when 'legal'
      @people = LegalPerson.all
    else
      @people = PhysicalPerson.all
    end
  end

  def filter_by_search_term
    return unless search.present?
    search =~ /\d/ ? doc_search : name_search
  end

  def doc_search
    doc = search.gsub(/\D/, '')
    @people = @people.where('doc LIKE ?', "%#{doc}%")
  end

  def name_search
    field = type == 'physical' ? 'name' : 'trading_name'
    @people = @people.where("#{field} ILIKE ?", "%#{search}%")
  end
end

app/controllers/people_controller.rb
class PeopleController < ApplicationController
  before_action :set_person, only: [:show, :edit, :update]

  def new
    @person = type_person
  end

  def index
    collection
    respond_with @people
    @people
  end

  def show
  end

  def edit
  end

  def update
    @person.update type_person_params
    respond_with @person, location: -> { person_path(@person, type: @person.class.type) }
  end

  def create
    @person = type_person
    @person.update type_person_params

    respond_with @person, location: -> { person_path(@person, type: @person.class.type) }
  end

  private

  def collection
    @filters = filter_params
    @people = AppFilters::People.new(@filters).filter
    @people = @people.page(params[:page])
  end

  def type_person
    case params[:type]
    when 'physical' then return PhysicalPerson.new
    when 'legal' then  return LegalPerson.new
    end
    PhysicalPerson.new
  end

  def set_person
    case params[:type]
    when 'physical' then @person = PhysicalPerson.find(params[:id])
    when 'legal' then @person = LegalPerson.find(params[:id])
    end
  end

  def type_person_params
    case params[:type]
    when 'physical' then return physical_person_params
    when 'legal' then return legal_person_params
    else raise 'Can\'t Verify the type of person'
    end
  end

  def physical_person_params
    params.require(:physical_person)
          .permit(:name, :doc, :rdoc, :mothers_name,
                  :profession, :born_at, :marital_status,
                  addresses_attributes: [:id, :name, :number, :additional,
                                         :neighborhood, :city, :state,
                                         :_destroy],
                  phones_attributes: [:id, :number, :_destroy])
  end

  def legal_person_params
    params.require(:legal_person)
          .permit(:legal_name, :doc, :trading_name, :state_registration,
                  addresses_attributes: [:id, :name, :number, :additional,
                                         :neighborhood, :city, :state,
                                         :_destroy],
                  phones_attributes: [:id, :number, :_destroy])
  end

  def filter_params
    return { type: 'physical' } unless params[:filters].present?
    params.require(:filters).permit(:search, :type)
  end

  def flash_interpolation_options
    { resource_name: @person.name }
  end
end

app/views/people/_filters.html.haml
.panel.panel-default
  .panel-heading
    %h3.panel-title
      = fa_icon :filter, text: 'Filtros', class: 'fa-fw'

  .panel-body
    %form.form-horizontal
      .form-group
        %label.col-xs-2.control-label Pesquisar
        .col-xs-10
          %input.form-control{ type: 'text', name: 'filters[search]', value: @filters[:search] }

      .form-group
        %label.col-xs-2.control-label Filtrar
        .col-xs-10
          .btn-group{ 'data-toggle' => 'buttons' }
            %label.btn.btn-default{ class: "#{ 'active' if @filters[:type] == 'physical' }"}
              %input{ type: 'radio', name: 'filters[type]', value: 'physical', id: 'physical', checked: (@filters[:type] == 'physical') }
              = model_with_icon PhysicalPerson, :plural

            %label.btn.btn-default{ class: "#{ 'active' if @filters[:type] == 'legal' }"}
              %input{ type: 'radio', name: 'filters[type]', value: 'legal', id: 'legal', checked: (@filters[:type] == 'legal') }
              = model_with_icon LegalPerson, :plural

      %button.btn.btn-success.pull-right{ type: 'submit' }
        = fa_icon 'angle-double-right', text: 'Filtrar', right: true, class: 'fa-fw'

      - if @filters[:search].present?
        = link_to people_path, class: 'btn btn-default' do
          = fa_icon :times, text: 'Limpar filtros', class: 'fa-fw'

app/views/people/_legal_table.html.haml
%table.table.table-hover.table-striped
  %thead
    %tr
      %th
      %th= LegalPerson.human_attribute_name(:legal_name)
      %th= LegalPerson.human_attribute_name(:trading_name)
      %th.text-center= LegalPerson.human_attribute_name(:doc)
      %th
  %tbody
    - @people.each do |person|
      - type = person.class.type
      %tr
        %td= fa_icon LegalPerson.icon, class: 'fa-2x'
        %td= link_to person.name, person_path(person, type: type)
        %td= person.trading_name
        %td.text-center= person.doc_with_mask
        %td.text-right
          .btn-group
            = button_to_edit edit_person_path(person, type: type), label: nil
            = button_to_show person_path(person, type: type), label: nil

app/views/people/_physical_table.html.haml
%table.table.table-hover.table-striped
  %thead
    %tr
      %th
      %th= PhysicalPerson.human_attribute_name(:name)
      %th.text-center= PhysicalPerson.human_attribute_name(:doc)
      %th= PhysicalPerson.human_attribute_name(:mothers_name)
      %th
  %tbody
    - @people.each do |person|
      - type = person.class.type
      %tr
        %td= fa_icon PhysicalPerson.icon, class: 'fa-2x'
        %td= link_to person.name, person_path(person, type: type)
        %td.text-center= person.doc_with_mask
        %td= person.mothers_name
        %td.text-right
          .btn-group
            = button_to_edit edit_person_path(person, type: type), label: nil
            = button_to_show person_path(person, type: type), label: nil

app/views/people/edit.html.haml
.page-header
  %h3= "Editando #{@person.name}"

= form_for @person, url: person_path(@person, type: @person.class.type) do |f|
  - if @person.is_a? PhysicalPerson
    = render 'people/forms/physical_person', f: f
  - else
    = render 'people/forms/legal_person', f: f

  .row
    .col-xs-12
      %hr
      = simple_submit f, :save, icon: :check, class: 'pull-right'

app/views/people/index.html.haml
.page-header
  .row
    .col-xs-8
      %h3
        = fa_icon :users, text: 'Pessoas'

    .col-xs-4.h3.text-right
      .btn-group
        = link_to new_person_path(type: 'physical'), class: 'btn btn-primary' do
          = fa_icon PhysicalPerson.icon, text: 'Adicionar nova pessoa'
        %button.btn.btn-primary.dropdown-toggle{ 'data-toggle' => 'dropdown' }
          %span.caret
        %ul.dropdown-menu.dropdown-menu-right
          %li
            = link_to new_person_path(type: 'legal') do
              = fa_icon LegalPerson.icon, text: 'Adicionar nova pessoa jurídica'

.row
  .col-sm-12
    = render 'filters'

.row.padt-top
  .col-sm-12
    - if @filters[:type] == 'physical'
      =  render 'physical_table'
    -  else
      = render 'legal_table'

  .col-sm-12.text-center
    = paginate @people

app/views/people/new.html.haml
.page-header
  %h3= fa_icon @person.class.icon, text: 'Nova pessoa'


= form_for @person, url: people_path(type: @person.class.type) do |f|
  = render 'shared/error_messages', model: @person
  - if @person.is_a? PhysicalPerson
    = render 'people/forms/physical_person', f: f
  - else
    = render 'people/forms/legal_person', f: f

  .row
    .col-xs-12
      %hr
      = simple_submit f, :save, icon: :check, class: 'pull-right'

app/views/people/show.html.haml
.page-header
  .row
    .col-xs-8
      %h3
        = fa_icon @person.class.icon, text: @person.name
    .col-xs-4.text-right.h3
      = button_to_edit edit_person_path(@person, type: @person.class.type)

.row
  .col-sm-6
    - if @person.is_a?(PhysicalPerson)
      = render 'people/show/physical_person'
    - else
      = render 'people/show/legal_person'

  .col-sm-6
    %h4= model_with_icon Phone, :plural
    %hr.legend

    - @person.phones.each do |phone|
      = show_attr_info phone, :number, method: :number_with_mask

.row
  .col-xs-12
    %h4= model_with_icon Address, :plural
    %hr.legend

    %ul
      - @person.addresses.each do |address|
        %li= address.full_address

.row.wow-padt-top
  .col-xs-12
    = render 'people/show/processes', person: @person